#ifndef _H_LIBCP_COLLECTIONS_VEC
#define _H_LIBCP_COLLECTIONS_VEC

#include "result.hpp"
#include <option.hpp>
#include <stddef.h>

template <typename T>
class Vec {
private:
    T* items;
    size_t count;
    size_t capacity;

public:
    Option<T*> nth(const size_t n);
    Option<const T*> nth(const size_t n) const;
    Option<T> pop();
    void push(const T& val);
    void push(T&& val);
    Result<void, const char*> reserve(size_t new_cap);
    void clear();
};

#endif // _H_LIBCP_COLLECTIONS_VEC