
#ifndef _H_LIBCP_OPTION
#define _H_LIBCP_OPTION
#include <stl.hpp>

template <typename T>
class Option {
    bool has_value = false;
    alignas(T) unsigned char storage[sizeof(T)];

public:
    Option() = default;
    Option(const T& val);
    Option(T&& val);
    ~Option();
    bool is_some() const;
    bool is_none() const;
    T& unwrap();
    const T& unwrap() const;
    T* operator->();
    T& operator*();
};

#endif // _H_LIBCP_OPTION