#ifndef _H_LIBCP_RESULT
#define _H_LIBCP_RESULT

#include <stl.hpp>

template <typename T, typename E>
class Result {
    bool is_okay = true;
    alignas(T) unsigned char ok_data[sizeof(T)];
    alignas(E) unsigned char err_data[sizeof(E)];

public:
    static Result ok(const T& val);
    static Result ok(T&& val);
    static Result err(const E& err);
    static Result err(E&& err);
    ~Result();
    bool is_ok() const;
    bool is_err() const;
    T& unwrap();
    E& unwrap_err();
};

template <typename E>
class Result<void, E> {
    bool is_okay = true;
    alignas(E) unsigned char err_data[sizeof(E)];

public:
    static Result ok();
    static Result err(const E& err);
    static Result err(E&& err);
    ~Result();
    bool is_ok() const;
    bool is_err() const;
    void unwrap();
    E& unwrap_err();
};

#endif // _H_LIBCP_RESULT